/*****************************************************/
/* createvm.c                                        */
/* -- Application demonstrates using Shell VxD       */
/*    protect mode API to create a hidden VM.        */
/*****************************************************/
#include <windows.h>
#include <mmsystem.h>
#include "shell.h"

typedef DWORD (FAR * LPFN)(void);

#ifdef __BORLANDC__
    #pragma argsused
#endif
int PASCAL WinMain(HINSTANCE hins, HINSTANCE hinsPrev,
  LPSTR lpsz, int wShow)
/*****************************************************/
/* -- Entry point.                                   */
/*****************************************************/
    {
    char  szPath[128], szExe[128], szBuf[128];
    char *pch;
    DWORD tim = timeGetTime();
    LPFN  lpfn;
    SEB   seb;
    DWORD hvm;

    /* Get Shell VxD's protect mode entry point. */
    _asm mov  ax, 1684h;
    _asm mov  bx, 0017h;
    _asm int  2fh;
    _asm mov  word ptr [lpfn], di;
    _asm mov  word ptr [lpfn + 2], es;
    if (NULL == lpfn)
        return 0;

    /* Check version number. */
    _asm mov  dx, 0;
    if (0x030a > (*lpfn)())
        return 0;

    /* Get path and working directory for DOS app. */
    for (pch = szPath + GetModuleFileName(hins,
        szPath, sizeof szPath) - 1;
      pch >= szPath; pch--)
        if (*pch == '\\' || *pch == ':')
            {
            *pch = 0;
            break;
            }
    wsprintf(szExe, "%s\\dosapp.exe", (LPSTR)szPath);

    /* Initialize Shell Execute Data structure. */
    seb.grfpif = fpifAltEnt | fpifAltPsc | fpifPrtSc |
      fpifCtlEsc | fpifAltTab | fpifAltEsc |
      fpifAltSp | fpifBack | fpifCloseE;
    seb.grfdis =
      0x00000010 | fdisEmText | fdisNoText | fdisNoLow;
    seb.wfpExe.ib = (WORD)szExe;
    seb.wfpExe.sel = SELECTOROF((LPVOID)&seb);
    seb.wfpArgs.ib = (WORD)"";
    seb.wfpArgs.sel = seb.wfpExe.sel;
    seb.wfpWork.ib = (WORD)szPath;
    seb.wfpWork.sel = seb.wfpExe.sel;
    seb.cpagWant = 0xffff;           /* Use default. */
    seb.cpagMin = 0xffff;            /* Use default. */
    seb.wForePriority = 100;         /* 0 to 10,000. */
    seb.wBackPriority = 50;          /* 0 to 10,000. */
    seb.ckbMaxEMS = 0x0400;
    seb.ckbMinEMS = 0x0000;
    seb.ckbMaxXMS = 0x4000;
    seb.ckbMinXMS = 0x0000;
    seb.wUnknown1 = seb.wUnknown2 = 0;
    lstrcpy(seb.szTitle, "Demo VM");

    /* Ask Shell to create the VM. */
    _asm lea  di, word ptr seb;
    _asm mov  dx, 3;
    _asm push es;
    _asm push ss;
    _asm pop  es;
    (*lpfn)();
    _asm pop  es;
// Borland and Symantec accept 'db', but Microsoft doesn't
#if defined(_MSC_VER)
    _asm _emit 66h;
#else
    _asm db 66h;
#endif
    _asm mov WORD PTR hvm, ax; /* Really EAX. */
    if (0 != hvm)
        {
        wsprintf(szBuf,
          "Created VM %lx, elapsed time %ld",
          hvm, timeGetTime() - tim);
        MessageBox(NULL, szBuf, "Hidden VM Demo",
          MB_OK);
        }
    return 0;
    }
